(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon-form', './util/createGetActions', './validator'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon-form'), require('./util/createGetActions'), require('./validator'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.melonForm, global.createGetActions, global.validator);
        global.Form = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _melonForm, _createGetActions, _validator) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _validator2 = _interopRequireDefault(_validator);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var JSONSchemaForm = function (_PureComponent) {
        _inherits(JSONSchemaForm, _PureComponent);

        function JSONSchemaForm() {
            var _ref;

            _classCallCheck(this, JSONSchemaForm);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            var _this = _possibleConstructorReturn(this, (_ref = JSONSchemaForm.__proto__ || Object.getPrototypeOf(JSONSchemaForm)).call.apply(_ref, [this].concat(args)));

            _this.getActions = _this.getActions.bind(_this);
            _this.validate = (0, _validator2.default)();
            return _this;
        }

        _createClass(JSONSchemaForm, [{
            key: 'getActions',
            value: function getActions(actions) {

                return {
                    upload: (0, _createGetActions.createUpload)(actions, this.props.upload)
                };
            }
        }, {
            key: 'render',
            value: function render() {

                return _react2.default.createElement(_melonForm.Form, _extends({}, this.props, {
                    validate: this.validate,
                    getActions: this.getActions }));
            }
        }]);

        return JSONSchemaForm;
    }(_react.PureComponent);

    exports.default = JSONSchemaForm;


    JSONSchemaForm.propTypes = _extends({}, _melonForm.Form.propTypes, {
        upload: _propTypes2.default.func
    });
});
//# sourceMappingURL=Form.js.map
