(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', './controls/Object'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('./controls/Object'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Object);
        global.Form = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Object) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.default = Form;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Object2 = _interopRequireDefault(_Object);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _objectWithoutProperties(obj, keys) {
        var target = {};

        for (var i in obj) {
            if (keys.indexOf(i) >= 0) continue;
            if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
            target[i] = obj[i];
        }

        return target;
    }

    /* eslint-disable fecs-prefer-class */
    /**
     * Form
     *
     * @class
     * @param {Object} props 属性
     */
    function Form(props) {
        var schema = props.schema,
            uiSchema = props.uiSchema,
            children = props.children,
            meta = props.meta,
            dispatch = props.dispatch,
            actions = props.actions,
            rest = _objectWithoutProperties(props, ['schema', 'uiSchema', 'children', 'meta', 'dispatch', 'actions']);

        return _react2.default.createElement(
            'form',
            rest,
            _react2.default.createElement(_Object2.default, {
                name: '',
                schema: schema,
                uiSchema: uiSchema
            }),
            children
        );
    }

    Form.propTypes = {
        schema: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]).isRequired,
        uiSchema: _propTypes2.default.object
    };
});
//# sourceMappingURL=Form.js.map
