(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'classnames'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('classnames'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.classnames);
        global.ValidityLabel = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _classnames) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.default = ValidityLabel;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _classnames2 = _interopRequireDefault(_classnames);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    /**
     * ValidityLabel
     *
     * @class
     * @param {Object} props 属性
     */
    function ValidityLabel(props) {
        var touched = props.touched,
            error = props.error,
            focus = props.focus;


        var message = !focus && touched && error ? error.message : '';

        var className = (0, _classnames2.default)('ui-control-validity-label', {
            'state-valid': !message,
            'state-invalid': message
        });

        return _react2.default.createElement(
            'div',
            { className: className },
            message ? message : null
        );
    } /**
       * @file ValidityLabel
       * @author leon <ludafa@outlook.com>
       */

    ValidityLabel.propTypes = {
        touched: _propTypes2.default.bool.isRequired
    };

    ValidityLabel.defaultProps = {
        touched: false
    };
});
//# sourceMappingURL=ValidityLabel.js.map
