(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon/Toggle', '../../factory', '../ValidityLabel', '../../util/createStateClassName'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon/Toggle'), require('../../factory'), require('../ValidityLabel'), require('../../util/createStateClassName'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Toggle, global.factory, global.ValidityLabel, global.createStateClassName);
        global.Boolean = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Toggle, _factory, _ValidityLabel, _createStateClassName) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.type = undefined;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Toggle2 = _interopRequireDefault(_Toggle);

    var factory = _interopRequireWildcard(_factory);

    var _ValidityLabel2 = _interopRequireDefault(_ValidityLabel);

    var _createStateClassName2 = _interopRequireDefault(_createStateClassName);

    function _interopRequireWildcard(obj) {
        if (obj && obj.__esModule) {
            return obj;
        } else {
            var newObj = {};

            if (obj != null) {
                for (var key in obj) {
                    if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];
                }
            }

            newObj.default = obj;
            return newObj;
        }
    }

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var type = exports.type = 'Boolean';

    var BooleanField = function (_PureComponent) {
        _inherits(BooleanField, _PureComponent);

        function BooleanField() {
            var _ref;

            _classCallCheck(this, BooleanField);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            var _this = _possibleConstructorReturn(this, (_ref = BooleanField.__proto__ || Object.getPrototypeOf(BooleanField)).call.apply(_ref, [this].concat(args)));

            _this.onChange = _this.onChange.bind(_this);
            return _this;
        }

        _createClass(BooleanField, [{
            key: 'onChange',
            value: function onChange(_ref2) {
                var value = _ref2.value;
                var _props = this.props,
                    name = _props.name,
                    actions = _props.actions;
                var validate = actions.validate,
                    change = actions.change;


                change(name, value);
                validate(name);
            }
        }, {
            key: 'render',
            value: function render() {
                var _props2 = this.props,
                    value = _props2.value,
                    schema = _props2.schema,
                    meta = _props2.meta,
                    disabled = _props2.disabled,
                    readOnly = _props2.readOnly;
                var title = schema.title,
                    description = schema.description;
                var touched = meta.touched,
                    error = meta.error;

                var invalid = touched && error && error.message;

                var className = (0, _createStateClassName2.default)('ui-control-boolean', this.props);

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    title ? _react2.default.createElement(
                        'header',
                        { className: 'ui-control-boolean-title' },
                        title
                    ) : null,
                    description ? _react2.default.createElement(
                        'p',
                        { className: 'ui-control-boolean-description' },
                        description
                    ) : null,
                    _react2.default.createElement(
                        'div',
                        { className: 'ui-control-boolean-content' },
                        _react2.default.createElement(_Toggle2.default, {
                            disabled: disabled,
                            readOnly: readOnly,
                            trueValue: true,
                            falseValue: false,
                            states: { invalid: invalid },
                            value: value == null ? schema.default : value,
                            onChange: this.onChange })
                    ),
                    _react2.default.createElement(_ValidityLabel2.default, meta)
                );
            }
        }]);

        return BooleanField;
    }(_react.PureComponent);

    exports.default = BooleanField;


    BooleanField.displayName = type;

    BooleanField.propTypes = {
        value: _propTypes2.default.bool
    };

    factory.registerControl(function (schema) {

        if (schema.type === 'boolean') {
            return BooleanField;
        }
    });
});
//# sourceMappingURL=Boolean.js.map
