(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', '../../factory'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('../../factory'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.factory);
        global.Control = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _factory) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.default = Control;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    /* eslint-disable fecs-prefer-class */
    /**
     * Control
     *
     * @class
     * @param {Object} props 属性
     */
    function Control(props) {

        var Control = (0, _factory.getControl)(props.schema);

        if (process.env.NODE_ENV === 'dev') {
            if (!Control) {
                throw new Error('no control match schema: \n' + JSON.stringify(props.schema, 0, 2));
            }
        }

        return _react2.default.createElement(Control, props);
    } /**
       * @file FieldControl
       * @author leon <ludafa@outlook.com>
       */

    Control.propTypes = {
        schema: _propTypes2.default.object.isRequired
    };
});
//# sourceMappingURL=Control.js.map
