(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon/Button', 'melon/Icon', '../../Field', '../Control', '../../../factory', '../../../util/field', '../../ValidityLabel', '../../../util/schema', '../../../util/createStateClassName'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon/Button'), require('melon/Icon'), require('../../Field'), require('../Control'), require('../../../factory'), require('../../../util/field'), require('../../ValidityLabel'), require('../../../util/schema'), require('../../../util/createStateClassName'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Button, global.Icon, global.Field, global.Control, global.factory, global.field, global.ValidityLabel, global.schema, global.createStateClassName);
        global.VariableArray = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Button, _Icon, _Field, _Control, _factory, _field, _ValidityLabel, _schema, _createStateClassName) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.VariableArrayItem = undefined;

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Button2 = _interopRequireDefault(_Button);

    var _Icon2 = _interopRequireDefault(_Icon);

    var _Field2 = _interopRequireDefault(_Field);

    var _Control2 = _interopRequireDefault(_Control);

    var _ValidityLabel2 = _interopRequireDefault(_ValidityLabel);

    var _createStateClassName2 = _interopRequireDefault(_createStateClassName);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var VariableArrayItem = exports.VariableArrayItem = function (_PureComponent) {
        _inherits(VariableArrayItem, _PureComponent);

        function VariableArrayItem() {
            var _ref;

            _classCallCheck(this, VariableArrayItem);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            var _this = _possibleConstructorReturn(this, (_ref = VariableArrayItem.__proto__ || Object.getPrototypeOf(VariableArrayItem)).call.apply(_ref, [this].concat(args)));

            _this.onRemove = _this.onRemove.bind(_this);
            _this.onUpward = _this.onUpward.bind(_this);
            _this.onDownward = _this.onDownward.bind(_this);
            return _this;
        }

        _createClass(VariableArrayItem, [{
            key: 'onUpward',
            value: function onUpward(e) {

                e.stopPropagation();

                var _props = this.props,
                    index = _props.index,
                    onUpward = _props.onUpward;


                onUpward(index);
            }
        }, {
            key: 'onDownward',
            value: function onDownward(e) {

                e.stopPropagation();

                var _props2 = this.props,
                    index = _props2.index,
                    onDownward = _props2.onDownward;


                onDownward(index);
            }
        }, {
            key: 'onRemove',
            value: function onRemove() {
                var _props3 = this.props,
                    index = _props3.index,
                    onRemove = _props3.onRemove;


                onRemove(index);
            }
        }, {
            key: 'render',
            value: function render() {
                var _props4 = this.props,
                    schema = _props4.schema,
                    uiSchema = _props4.uiSchema,
                    name = _props4.name,
                    removable = _props4.removable,
                    downable = _props4.downable,
                    index = _props4.index,
                    disabled = _props4.disabled,
                    readOnly = _props4.readOnly;


                var upButton = index ? _react2.default.createElement(
                    _Button2.default,
                    {
                        type: 'button',
                        size: 'xxs',
                        variants: ['info', 'icon'],
                        onClick: this.onUpward },
                    _react2.default.createElement(_Icon2.default, { icon: 'arrow-upward' })
                ) : null;

                var downButton = downable ? _react2.default.createElement(
                    _Button2.default,
                    {
                        type: 'button',
                        size: 'xxs',
                        variants: ['info', 'icon'],
                        onClick: this.onDownward },
                    _react2.default.createElement(_Icon2.default, { icon: 'arrow-downward' })
                ) : null;

                var deleteButton = removable ? _react2.default.createElement(
                    _Button2.default,
                    {
                        type: 'button',
                        size: 'xxs',
                        variants: ['danger', 'icon'],
                        onClick: this.onRemove },
                    _react2.default.createElement(_Icon2.default, { icon: 'delete' })
                ) : null;

                var title = _react2.default.createElement(
                    'header',
                    { className: 'ui-control-variable-array-item-title' },
                    _react2.default.createElement(
                        'label',
                        null,
                        index + 1,
                        '.'
                    ),
                    upButton,
                    downButton,
                    deleteButton
                );

                return _react2.default.createElement(
                    'div',
                    { className: 'ui-control-variable-array-item' },
                    title,
                    _react2.default.createElement(
                        'div',
                        { className: 'ui-control-variable-array-item-content' },
                        _react2.default.createElement(_Field2.default, {
                            disabled: disabled,
                            readOnly: readOnly,
                            name: name,
                            schema: schema,
                            uiSchema: uiSchema,
                            control: _Control2.default,
                            format: _field.format })
                    )
                );
            }
        }]);

        return VariableArrayItem;
    }(_react.PureComponent);

    VariableArrayItem.propTypes = {
        schema: _propTypes2.default.object,
        index: _propTypes2.default.number,
        removable: _propTypes2.default.bool,
        downable: _propTypes2.default.bool,
        upable: _propTypes2.default.bool,
        onUpward: _propTypes2.default.func,
        onDownward: _propTypes2.default.func,
        onRemove: _propTypes2.default.func
    };

    var VariableArray = function (_PureComponent2) {
        _inherits(VariableArray, _PureComponent2);

        function VariableArray() {
            var _ref2;

            _classCallCheck(this, VariableArray);

            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = arguments[_key2];
            }

            var _this2 = _possibleConstructorReturn(this, (_ref2 = VariableArray.__proto__ || Object.getPrototypeOf(VariableArray)).call.apply(_ref2, [this].concat(args)));

            _this2.onFieldUpward = _this2.onFieldUpward.bind(_this2);
            _this2.onFieldDownward = _this2.onFieldDownward.bind(_this2);
            _this2.onFieldRemove = _this2.onFieldRemove.bind(_this2);
            _this2.onFieldAdd = _this2.onFieldAdd.bind(_this2);
            return _this2;
        }

        _createClass(VariableArray, [{
            key: 'onFieldAdd',
            value: function onFieldAdd() {
                var _props5 = this.props,
                    actions = _props5.actions,
                    name = _props5.name,
                    schema = _props5.schema;


                actions.arrayPush(name, (0, _schema.fill)(void 0, schema.items));
                actions.validate(name);
            }
        }, {
            key: 'onFieldUpward',
            value: function onFieldUpward(index) {
                var _props6 = this.props,
                    actions = _props6.actions,
                    name = _props6.name;


                actions.arraySwap(name, index, index - 1);
                actions.validate(name);
            }
        }, {
            key: 'onFieldDownward',
            value: function onFieldDownward(index) {
                var _props7 = this.props,
                    actions = _props7.actions,
                    name = _props7.name;


                actions.arraySwap(name, index, index + 1);
                actions.validate(name);
            }
        }, {
            key: 'onFieldRemove',
            value: function onFieldRemove(index) {
                var _props8 = this.props,
                    actions = _props8.actions,
                    name = _props8.name;


                actions.arraySplice(name, index, 1);
                actions.validate(name);
            }
        }, {
            key: 'render',
            value: function render() {
                var _this3 = this;

                var _props9 = this.props,
                    name = _props9.name,
                    schema = _props9.schema,
                    value = _props9.value,
                    uiSchema = _props9.uiSchema,
                    meta = _props9.meta,
                    disabled = _props9.disabled,
                    readOnly = _props9.readOnly;
                var items = schema.items,
                    _schema$minItems = schema.minItems,
                    minItems = _schema$minItems === undefined ? 0 : _schema$minItems,
                    _schema$maxItems = schema.maxItems,
                    maxItems = _schema$maxItems === undefined ? Number.MAX_VALUE : _schema$maxItems,
                    title = schema.title,
                    description = schema.description;


                if (!Array.isArray(value)) {
                    value = [];
                }

                var addButton = !readOnly && maxItems > value.length ? _react2.default.createElement(
                    _Button2.default,
                    {
                        disabled: disabled,
                        type: 'button',
                        size: 'xxs',
                        variants: ['icon', 'info'],
                        onClick: this.onFieldAdd },
                    _react2.default.createElement(_Icon2.default, { icon: 'add' })
                ) : null;

                var fields = value.length ? value.map(function (record, index, arr) {
                    var key = name + '[' + index + ']';
                    return _react2.default.createElement(VariableArrayItem, {
                        key: key,
                        name: key,
                        schema: items,
                        uiSchema: uiSchema && uiSchema.$items,
                        index: index,
                        disabled: disabled,
                        readOnly: readOnly,
                        removable: !disabled && !readOnly && minItems < arr.length,
                        downable: !disabled && !readOnly && index < arr.length - 1,
                        upable: !disabled && !readOnly && index > 1,
                        onUpward: _this3.onFieldUpward,
                        onDownward: _this3.onFieldDownward,
                        onRemove: _this3.onFieldRemove });
                }) : _react2.default.createElement(
                    'p',
                    { className: 'ui-control-variable-array-empty-list' },
                    _react2.default.createElement(
                        _Button2.default,
                        {
                            disabled: disabled || readOnly,
                            type: 'button',
                            size: 'xs',
                            variants: ['info'],
                            onClick: this.onFieldAdd },
                        '\u6682\u65E0\u6761\u76EE\uFF0C\u70B9\u51FB\u6DFB\u52A0'
                    )
                );

                var className = (0, _createStateClassName2.default)('ui-control-variable-array', this.props);

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    _react2.default.createElement(
                        'header',
                        { className: 'ui-control-variable-array-title' },
                        title,
                        addButton
                    ),
                    description ? _react2.default.createElement(
                        'p',
                        { className: 'ui-control-variable-array-description' },
                        description
                    ) : null,
                    _react2.default.createElement(_ValidityLabel2.default, meta),
                    _react2.default.createElement(
                        'ul',
                        { className: 'ui-control-variable-array-list' },
                        fields
                    )
                );
            }
        }]);

        return VariableArray;
    }(_react.PureComponent);

    exports.default = VariableArray;


    VariableArray.displayName = 'VariableArray';

    VariableArray.propTypes = {
        name: _propTypes2.default.string.isRequired,
        schema: _propTypes2.default.object.isRequired,
        uiSchema: _propTypes2.default.object,
        actions: _propTypes2.default.object.isRequired,
        value: _propTypes2.default.array
    };

    (0, _factory.registerControl)(function (schema) {
        var type = schema.type,
            items = schema.items;


        if (type === 'array' && !Array.isArray(items)) {
            return VariableArray;
        }
    });
});
//# sourceMappingURL=VariableArray.js.map
