(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon/Select', '../../ValidityLabel', '../../../factory', '../../../util/createStateClassName'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon/Select'), require('../../ValidityLabel'), require('../../../factory'), require('../../../util/createStateClassName'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Select, global.ValidityLabel, global.factory, global.createStateClassName);
        global.Enum = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Select, _ValidityLabel, _factory, _createStateClassName) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Select2 = _interopRequireDefault(_Select);

    var _ValidityLabel2 = _interopRequireDefault(_ValidityLabel);

    var _createStateClassName2 = _interopRequireDefault(_createStateClassName);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var EnumTextField = function (_PureComponent) {
        _inherits(EnumTextField, _PureComponent);

        function EnumTextField() {
            _classCallCheck(this, EnumTextField);

            return _possibleConstructorReturn(this, (EnumTextField.__proto__ || Object.getPrototypeOf(EnumTextField)).apply(this, arguments));
        }

        _createClass(EnumTextField, [{
            key: 'render',
            value: function render() {
                var _props = this.props,
                    schema = _props.schema,
                    value = _props.value,
                    name = _props.name,
                    actions = _props.actions,
                    meta = _props.meta,
                    disabled = _props.disabled,
                    readOnly = _props.readOnly;
                var title = schema.title,
                    description = schema.description,
                    enumNames = schema.enumNames;
                var error = meta.error,
                    touched = meta.touched;


                var valid = touched && error && error.message;

                var className = (0, _createStateClassName2.default)('ui-control-enum', this.props);

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    title ? _react2.default.createElement(
                        'header',
                        {
                            className: 'ui-control-enum-title' },
                        title
                    ) : null,
                    description ? _react2.default.createElement(
                        'p',
                        {
                            className: 'ui-control-enum-description' },
                        description
                    ) : null,
                    _react2.default.createElement(
                        _Select2.default,
                        {
                            disabled: disabled,
                            readOnly: readOnly,
                            size: 'xxs',
                            variants: ['fluid'],
                            name: name,
                            states: { valid: valid },
                            maxHeight: 300,
                            value: value == null ? schema.defaultValue : value,
                            onChange: function onChange(e) {
                                actions.change(name, e.value);
                                actions.validate(name);
                            } },
                        schema.enum.map(function (item, index) {
                            return _react2.default.createElement(
                                'option',
                                { key: item, value: item },
                                enumNames && enumNames[index] || item
                            );
                        })
                    ),
                    _react2.default.createElement(_ValidityLabel2.default, meta)
                );
            }
        }]);

        return EnumTextField;
    }(_react.PureComponent);

    exports.default = EnumTextField;


    EnumTextField.propTypes = {
        schema: _propTypes2.default.object.isRequired,
        value: _propTypes2.default.string
    };

    (0, _factory.registerControl)(function (schema) {

        if (schema.type === 'string' && schema.enum) {
            return EnumTextField;
        }
    });
});
//# sourceMappingURL=Enum.js.map
