(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon/Uploader', '../../../factory', '../../ValidityLabel', '../../../util/createStateClassName'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon/Uploader'), require('../../../factory'), require('../../ValidityLabel'), require('../../../util/createStateClassName'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Uploader, global.factory, global.ValidityLabel, global.createStateClassName);
        global.Image = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Uploader, _factory, _ValidityLabel, _createStateClassName) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Uploader2 = _interopRequireDefault(_Uploader);

    var _ValidityLabel2 = _interopRequireDefault(_ValidityLabel);

    var _createStateClassName2 = _interopRequireDefault(_createStateClassName);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Image = function (_PureComponent) {
        _inherits(Image, _PureComponent);

        function Image() {
            _classCallCheck(this, Image);

            return _possibleConstructorReturn(this, (Image.__proto__ || Object.getPrototypeOf(Image)).apply(this, arguments));
        }

        _createClass(Image, [{
            key: 'render',
            value: function render() {
                var _props = this.props,
                    schema = _props.schema,
                    value = _props.value,
                    name = _props.name,
                    actions = _props.actions,
                    meta = _props.meta;
                var title = schema.title,
                    description = schema.description;
                var pending = meta.pending,
                    touched = meta.touched,
                    error = meta.error;


                var invalid = touched && error && error.message;

                var className = (0, _createStateClassName2.default)('ui-control-image', this.props);

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    title ? _react2.default.createElement(
                        'header',
                        {
                            className: 'ui-control-image-title' },
                        title
                    ) : null,
                    description ? _react2.default.createElement(
                        'p',
                        {
                            className: 'ui-control-image-decription' },
                        description
                    ) : null,
                    _react2.default.createElement(_Uploader2.default, {
                        size: 'xxs',
                        variants: ['fluid'],
                        style: { maxWidth: '100%' },
                        states: { invalid: invalid },
                        uploading: pending,
                        onFileChange: function onFileChange(file) {
                            return file ? actions.upload(name, file) : actions.change(name, '');
                        },
                        onUploadCancel: function onUploadCancel() {
                            return actions.stopPending(name);
                        },
                        value: value }),
                    _react2.default.createElement(_ValidityLabel2.default, meta)
                );
            }
        }]);

        return Image;
    }(_react.PureComponent);

    exports.default = Image;


    Image.propTypes = {
        schema: _propTypes2.default.object.isRequired,
        value: _propTypes2.default.string
    };

    (0, _factory.registerControl)(function (schema) {

        if (schema.type === 'string' && schema.media && /^image\//.test(schema.media.type)) {
            return Image;
        }
    });
});
//# sourceMappingURL=Image.js.map
