(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', 'prop-types', 'melon/Slider', '../../../factory', '../../ValidityLabel', '../../../util/createStateClassName'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('prop-types'), require('melon/Slider'), require('../../../factory'), require('../../ValidityLabel'), require('../../../util/createStateClassName'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.propTypes, global.Slider, global.factory, global.ValidityLabel, global.createStateClassName);
        global.Range = mod.exports;
    }
})(this, function (exports, _react, _propTypes, _Slider, _factory, _ValidityLabel, _createStateClassName) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _propTypes2 = _interopRequireDefault(_propTypes);

    var _Slider2 = _interopRequireDefault(_Slider);

    var _ValidityLabel2 = _interopRequireDefault(_ValidityLabel);

    var _createStateClassName2 = _interopRequireDefault(_createStateClassName);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Range = function (_PureComponent) {
        _inherits(Range, _PureComponent);

        function Range() {
            _classCallCheck(this, Range);

            return _possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).apply(this, arguments));
        }

        _createClass(Range, [{
            key: 'render',
            value: function render() {
                var _props = this.props,
                    schema = _props.schema,
                    value = _props.value,
                    name = _props.name,
                    actions = _props.actions,
                    meta = _props.meta;
                var formatMaximum = schema.formatMaximum,
                    _schema$formatMinimum = schema.formatMinimum,
                    formatMinimum = _schema$formatMinimum === undefined ? 0 : _schema$formatMinimum,
                    title = schema.title,
                    description = schema.description;
                var error = meta.error,
                    touched = meta.touched;


                value = isNaN(+value) ? formatMinimum : value;

                var invalid = touched && error && error.message;

                var className = (0, _createStateClassName2.default)('ui-control-range', this.props);

                return _react2.default.createElement(
                    'div',
                    { className: className },
                    title ? _react2.default.createElement(
                        'header',
                        {
                            className: 'ui-control-range-title' },
                        title
                    ) : null,
                    description ? _react2.default.createElement(
                        'p',
                        {
                            className: 'ui-control-range-decription' },
                        description
                    ) : null,
                    _react2.default.createElement(_Slider2.default, {
                        size: 'xxs',
                        variants: ['fluid'],
                        name: name,
                        value: +value,
                        maximum: +formatMaximum,
                        minimum: +formatMinimum,
                        states: { invalid: invalid },
                        onChange: function onChange(e) {
                            actions.change(name, e.value + '');
                            actions.validate(name);
                        } }),
                    _react2.default.createElement(_ValidityLabel2.default, meta)
                );
            }
        }]);

        return Range;
    }(_react.PureComponent);

    exports.default = Range;


    Range.propTypes = {
        schema: _propTypes2.default.object.isRequired
    };

    (0, _factory.registerControl)(function (schema) {
        var type = schema.type,
            format = schema.format,
            formatMaximum = schema.formatMaximum,
            formatMinimum = schema.formatMinimum;


        if (type === 'string' && format === 'numeric' && formatMaximum != null && formatMinimum != null) {
            return Range;
        }
    });
});
//# sourceMappingURL=Range.js.map
